'---------------------------------------------------------
'YELLSUB.BAS for RapidQ - Written by Dieter Folger
'Simple screensaver example; the Beatles' Yellow
'Submarine is moved around the screen. It can be
'used when renamed to YELLSUB.SCR and put it in the
'\WINDOWS\SYSTEM directory.
'---------------------------------------------------------
$RESOURCE ys0 AS "ysub0.bmp" ' 2 bitmaps
$RESOURCE ys1 as "ysub1.bmp" ' 150x90 pixels
 
DECLARE SUB Resize
DECLARE SUB ShowSub
DECLARE SUB MoveSub
DECLARE SUB CheckMouse

DIM Ysub0 as qBitmap
ysub0.BmpHandle = ys0
DIM Ysub1 AS qBitmap
ysub1.BmpHandle = ys1

DIM x AS INTEGER, y AS INTEGER
DIM oldX AS INTEGER, oldY AS INTEGER
DIM xdir AS BYTE, ydir AS BYTE, Help AS BYTE

RANDOMIZE
x = RND(Screen.Width) : y = RND(Screen.Height)

CREATE Form AS qForm
       Width = Screen.Width
       Height = Screen.Height
       Color = 0
       BorderStyle = 0
       onResize = Resize
       CREATE Canvas AS qCanvas
              Cursor = -1
              onPaint = ShowSub
              onMouseMove = CheckMouse
       END CREATE
END CREATE
CREATE MyTimer AS qTimer
       Interval = 1
       onTimer = MoveSub
END CREATE

Form.ShowModal

SUB Resize
  Canvas.Height = Form.ClientHeight
  Canvas.Width = Form.ClientWidth
END SUB

SUB ShowSub
  IF xdir THEN Canvas.Draw x, y, ysub1.bmp
  IF xdir = 0  THEN Canvas.Draw x, y, ysub0.bmp
END SUB

SUB MoveSub
  IF x > Screen.Width THEN xdir = 1
  IF x < -160 THEN xdir = 0  
  IF y > Screen.Height THEN ydir = 1
  IF y < -100 THEN ydir = 0
  IF xdir then x = x - 3 ELSE x = x + 3
  IF ydir then y = y - 1 ELSE y = y + 1
  ShowSub
END SUB

SUB CheckMouse
  IF Help THEN IF MouseX <> oldX OR MouseY <> oldY THEN END 
  oldX = MouseX : oldY = MouseY
  Help = 1
END SUB

